package rayTrace;



public class Box extends Collection {

	
	/** Create box aligned to axes from corner1 to corner2 */
	public Box(double corner1[], double corner2[], int matType, double innerRIndex, double outerRIndex, double reHitTolerence) {
		super(null);
		
		for(int i=0;i<3;i++)
			centre[i] = (corner1[i] + corner2[i]) / 2.0;
		
		double w = corner2[0] - corner1[0]; //width (x) 
		double d = corner2[1] - corner1[1]; //depth (y)
		double h = corner2[2] - corner1[2]; //height (z)
		
		elems = new Element[6];
		elems[0] = new Square(new double[]{ centre[0] + (w/2.0), centre[1], centre[2] }, new double[]{ 1, 0, 0 }, new double[]{ 0, 1, 0 }, d, h, matType, outerRIndex,innerRIndex, reHitTolerence); // right (+x)
		elems[1] = new Square(new double[]{ centre[0] - (w/2.0), centre[1], centre[2] }, new double[]{ -1, 0, 0 }, new double[]{ 0, 1, 0 }, d, h, matType, outerRIndex,innerRIndex, reHitTolerence); // left (-x)
		elems[2] = new Square(new double[]{ centre[0], centre[1] + (d/2.0), centre[2] }, new double[]{ 0, 1, 0 }, new double[]{ 1, 0, 0 }, w, h, matType, outerRIndex,innerRIndex, reHitTolerence); // back (+y)
		elems[3] = new Square(new double[]{ centre[0], centre[1] - (d/2.0), centre[2] }, new double[]{ 0, -1, 0 }, new double[]{ 1, 0, 0 }, w, h, matType, outerRIndex,innerRIndex, reHitTolerence); // front (-y)
		elems[4] = new Square(new double[]{ centre[0], centre[1], centre[2] + (h/2.0) }, new double[]{ 0, 0, 1 }, new double[]{ 1, 0, 0 }, w, d, matType, outerRIndex,innerRIndex, reHitTolerence); // top (+z)
		elems[5] = new Square(new double[]{ centre[0], centre[1], centre[2] - (h/2.0) }, new double[]{ 0, 0, -1 }, new double[]{ 1, 0, 0 }, w, d, matType, outerRIndex,innerRIndex, reHitTolerence); // bottom (-z)
		
		

	}

}
