package rayTrace;



public class Iris extends Plane {
	
	double discRadius;
	double apatureRadius;
	
	public Iris(double centre[], double normal[], double discRadius, double apatureRadius, int matType, double frontRIndex, double backRIndex, double reHitTolerence) {
		super(centre,normal,matType,frontRIndex,backRIndex,reHitTolerence);
		this.discRadius = discRadius;
		this.apatureRadius = apatureRadius;
	}
	
	public double boundingSphereRadius(){ return discRadius; } 
	
	
	public Intersection findIntersection(Ray ray){
		
		Intersection hit = super.findIntersection(ray); //find the place where the ray hits us (as if we were an infinite plane)
		
		if(hit == null || hit.distAlongRay < 0) //didn't hit the plane (probably parallel)
			return null;
		
		double sum=0;
		
		for(int i=0;i<3;i++)
			sum += (centre[i] - hit.pos[i]) * (centre[i] - hit.pos[i]);
		
		hit.object = this;
		
		if( sum <= (discRadius*discRadius) && sum >= (apatureRadius*apatureRadius)) //if inside the disc radius but outside the apature radius	
			return hit;
		else
			return null;
	}
	
	/*
	 * 	/test for intersection of a flat disc and a ray
		function [xPos,xNorm,dist] = discIntersect(ray, disc)
			[xPos,dist] = planeIntersect(ray,disc.centre,disc.normal);
			
			if (sum((disc.centre - xPos)^2) <= (disc.radius^2)) & (dist > 0)
				xNorm = disc.normal;
			else
				xNorm = [0,0,0];
			end;
		endfunction
	 */
}
