package rayTrace;


public class Lens extends Collection {

	double radiusOfCurv;
	double diameter;
	
	public Lens(double centre[], double normal[], double radiusOfCurvature, double diameter, int matType, double rIndexInner, double rIndexOuter, double reHitTolerence) {
		super(null);
		this.matType = matType;
		this.diameter = diameter;
		this.radiusOfCurv = radiusOfCurvature;
		System.arraycopy(centre, 0, this.centre, 0, 3);
		
		double halfWidth = radiusOfCurv - Math.sqrt(radiusOfCurv*radiusOfCurv - 0.25*diameter*diameter);
		
		double C1[] = new double[3];
		double C2[] = new double[3];
		double N2[] = new double[3];
		
		for(int i=0;i<3;i++){
			C1[i] = centre[i] - halfWidth * normal[i];
			C2[i] = centre[i] + halfWidth * normal[i];
			N2[i] = -normal[i];
		}
		
		elems = new Dish[]{
		 new Dish(C1, normal, radiusOfCurv, diameter, matType, rIndexInner, rIndexOuter, reHitTolerence),
		 new Dish(C2, N2,     radiusOfCurv, diameter, matType, rIndexInner, rIndexOuter, reHitTolerence)
		};
	}
}
